// check to see if the browser supports
// the addEventListener function 
if(window.addEventListener) 
{
	window.addEventListener 
	( 
		'load', // this is the load event 
		onLoad, // this is the event handler we are going to write 
		false // useCapture boolean value 
	);
	// the window load event handler 
	function onLoad() 
	{ 
		//Objects
		var canvas;
		var context;
		var house;
		var tree;
		var snowman;
		var moon;
		var snow;
		var star;
		var santa;
		
		//Vectors
		var v1;
		var v2;
		var v3;
		
		// this function will initialise our variables 
		function initialise() 
		{ 
			// Find the canvas element using its id attribute. 
			canvas = document.getElementById('canvas'); 
			// if it couldn't be found 
			if (!canvas) 
			{
				// make a message box pop up with the error. 
				alert('Error: I cannot find the canvas element!'); 
				return; 
			}
			// check if there is a getContext function 
			if (!canvas.getContext) 
			{ 
				// make a message box pop up with the error. 
				alert('Error: no canvas.getContext!'); 
				return; 
			}
			// Get the 2D canvas context. 
			context = canvas.getContext('2d'); 
			if (!context) 
			{ 
				alert('Error: failed to getContext!');
				return; 
			}
			// check to see if the browser supports 
			// the addEventListener function 
			if (window.addEventListener) 
			{ 
				window.addEventListener('load', onLoad, false); 
				window.addEventListener('keydown', onKeyDown, false); 
			} 

			// canvasWidth = canvas.width;
			// canvasHeight = canvas.height;
			// canvas.translate(canvasWidth / 2,canvasHeight/2);
			// window.addEventListener('resize',resizeWindow);
			// resizeWindow();
			
			house = new Array();
			moon = new Array();
			snowman = new Array();
			tree = new Array();
			star = new Array();
			santa = new Array();
			snow = new Array();
			var fallingVectors = new Array();
			
			var xCor = Math.floor((Math.random()*800)+1);
			var yCor = Math.floor((Math.random()*10)+1);
			
			for(i=0;i<50;i++)
			{
				fallingVectors.push(new Vector(xCor,yCor));
			}
			
			

			tree.push(new Tree(-20,-150));
			house.push(new House(0,0,'7F0000'));
			//house.push(new House(-130,-250,'7F0000'));
			//house.push(new House(100,-200,'7F0000'));
			moon.push(new Moon(-250,-210));
			snowman.push(new Snowman(200,100));
			star.push(new Star(-48,-225));
			santa.push(new Santa(-500,150,0));
			for (i=0;i<50;i++)
			{
				snow.push(new Snow(-400,-500,fallingVectors[i].getX(),fallingVectors[i].getY()));
			}
			
		}
		// function resizeWindow()
		// {
			// var windowWidth = window.innerWidth;
			// var windowHeight = window.innerHeight;
			
			// var scaleValue = Math.min(windowWidth / canvasWidth,windowHeight/canvasHeight);
			
			// if(windowWidth <= canvasWidth || windowHeight <= canvasHeight)
			// {
				// context.scale(scaleValue,scaleValue);
				// canvas.width = canvasWidth * scale;
				// canvas.height = canvasHeight * scale
			// }
			// else
			// {
				// context.scale(1,1);
				// convas.width = canvasWidth;
				// canvas.height = canvasHeight;
			// }
		// }
		
		function onKeyDown(event)
		{ 
			var keyCode = event.keyCode; 
			if(keycode == 70)
			{
				context.fillStyle="#000000";
				context.font="20px Arial";
				context.fillText("Happy Holidays!",0,0);
			}
		}; 

		
		// this function will actually draw on the canvas 
		function draw()
		{ 
			context.save();
			//Night sky.
			context.fillStyle = "#050019";
			context.fillRect(0,0,canvas.width,(canvas.height/2));
			//Snow
			context.fillStyle = "#FFFFFF";
			context.beginPath();
			context.moveTo(0,canvas.height/2);
			context.quadraticCurveTo(40,200,canvas.width,canvas.height/2);
			context.lineTo(canvas.width, canvas.height);
			context.lineTo(0, canvas.height);
			context.lineTo(0, canvas.height/2);
			context.closePath();
			context.fill();
			context.stroke();
			context.restore();
			
			
			context.translate(canvas.width * 0.5, canvas.height * 0.5);
			
			moon[0].draw(context);
			tree[0].draw(context);
			house[0].draw(context);
			//house[1].draw(context);
			//house[2].draw(context);
			snowman[0].draw(context);
			star[0].draw(context);
			santa[0].draw(context);
			context.restore();
			for (i=0;i<50;i++)
			{
				snow[i].draw(context);
			}
			
		}
		
		function update()
		{
			//update functions for objects
			santa[0].update(context);
			for (i=0;i<50;i++)
			{
				snow[i].update(context);
			}
			
		}
		
		function animationLoop()
		{
			update();
			context.translate(-400,-300);
			draw();
			webkitRequestAnimationFrame(animationLoop);
		}

		
		// call the initialise and draw functions 
		initialise();
		draw();
		animationLoop();
	}
}