var House = (function () 
{
	function House(pX, pY, pDoorColour) {
		houseVectors = new Array();
		for(i =0;i<3;i++)
		{
			if (i == 0)
				houseVectors[0] = new Vector(-350 ,-250);
			if (i == 1)
				houseVectors[1] = new Vector(-100,-230);
			if (i == 2)
				houseVectors[2] = new Vector(150,-200);
		}
		this.setDoorColour(pDoorColour);
	};
	
	House.prototype.getDoorColour = function()
	{
		return this.mDoorColour;
	}; 
	House.prototype.setDoorColour = function (pDoorColour)
	{
		this.mDoorColour = pDoorColour;
	};
	House.prototype.draw = function(pContext)
	{ 
		for(i = 0; i < 3; i++)
		{
			pContext.save();
			pContext.translate(houseVectors[i].getX(),houseVectors[i].getY());
		
			this.drawBaseHouse(pContext);
			this.drawWhitePart(pContext);
			this.drawWindows(pContext);
			this.drawDoor(pContext);
			pContext.restore();
		}
	};
	House.prototype.drawBaseHouse = function(pContext)
	{ 
		pContext.lineWidth = 5;
		pContext.strokeStyle = '#FFFFFF';
		//Base House + Roof
		pContext.beginPath();
		pContext.fillStyle = '#7F0000';
		pContext.moveTo(150,100);
		pContext.lineTo(250,200);
		pContext.lineTo(250,300);
		pContext.lineTo(50,300);
		pContext.lineTo(50,200);
		pContext.lineTo(150,100);
		pContext.closePath();
		pContext.fill();
		pContext.stroke();
		
	}
	
	House.prototype.drawWhitePart = function(pContext)
	{
		pContext.lineWidth = 5;
		pContext.strokeStyle = '#000000';
		//Front Facing White Part
		pContext.beginPath();
		pContext.fillStyle = '#FFFFFF';
		pContext.moveTo(250,200);
		pContext.lineTo(250,300);
		pContext.lineTo(50,300);
		pContext.lineTo(50,200);
		pContext.lineTo(250,200);
		pContext.fill();
		pContext.stroke();
		pContext.closePath();
	}
	
	House.prototype.drawWindows = function(pContext)
	{
		pContext.lineWidth = 5;
		pContext.strokeStyle = '#000000';
		//Windows (Left)
		pContext.beginPath();
		pContext.fillStyle = '#494949';
		pContext.moveTo(75,230);
		pContext.lineTo(110,230);
		pContext.lineTo(110,280);
		pContext.lineTo(75,280);
		pContext.lineTo(75,230);
		pContext.fill();
		pContext.stroke();
		pContext.closePath();
			
		pContext.beginPath();
		pContext.fillStyle = '#494949';
		pContext.moveTo(92,230);
		pContext.lineTo(92,280);
		pContext.stroke();
		pContext.closePath();
			
		pContext.beginPath();
		pContext.fillStyle = '#494949';
		pContext.moveTo(75,255);
		pContext.lineTo(110,255);
		pContext.stroke();
		pContext.closePath();
			
		//Windows (Right)
			
		pContext.beginPath();
		pContext.fillStyle = '#494949';
		pContext.moveTo(190,230);
		pContext.lineTo(225,230);
		pContext.lineTo(225,280);
		pContext.lineTo(190,280);
		pContext.lineTo(190,230);
		pContext.fill();
		pContext.stroke();
		pContext.closePath();
			
		pContext.beginPath();
		pContext.fillStyle = '#494949';
		pContext.moveTo(208,230);
		pContext.lineTo(208,280);
		pContext.stroke();
		pContext.closePath();
			
		pContext.beginPath();
		pContext.fillStyle = '#494949';
		pContext.moveTo(190,255);
		pContext.lineTo(225,255);
		pContext.stroke();
		pContext.closePath();
	}
	
	House.prototype.drawDoor = function(pContext)
	{
		pContext.lineWidth = 5;
		pContext.strokeStyle = '#000000';
		//Red Door
		pContext.beginPath();
		pContext.fillStyle = '#7F0000';
		pContext.moveTo(130,240);
		pContext.lineTo(175,240);
		pContext.lineTo(175,300);
		pContext.lineTo(130,300);
		pContext.lineTo(130,240);
		pContext.fill();
		pContext.stroke();
		pContext.closePath();
	}
	
	
	return House; 
})();