var Snowman = (function () {
	function Snowman(pX, pY) {
		snowmanVectors = new Vector(pX,pY);		
	};
	
	Snowman.prototype.draw = function(pContext)
	{ 
		pContext.save();
		pContext.translate(snowmanVectors.getX(),snowmanVectors.getY());
		this.drawSnowmanWhole(pContext);
		pContext.restore();
	};
	
	Snowman.prototype.drawSnowmanWhole = function(pContext)
	{ 
		this.baseSnowman(pContext);
		this.buttons(pContext,-10,-8);
		this.buttons(pContext,10,-8);
		this.buttons(pContext,0,30);
		this.buttons(pContext,0,45);
		this.buttons(pContext,0,60);
		pContext.save();
		pContext.translate(-20,-30);
		this.snowmanHat(pContext);
		pContext.restore();
		pContext.save();
		pContext.translate(37,37);
		pContext.rotate(-0.2);
		this.arms(pContext);
		pContext.restore();
		pContext.save();
		pContext.scale(-1,-1);
		pContext.translate(33,-30);
		pContext.rotate(0.2);
		this.arms(pContext);
		pContext.restore();
		pContext.save();
		pContext.translate(0,0);
		this.carrotNose(pContext);
		pContext.restore();
		
	};
	
	Snowman.prototype.baseSnowman = function(pContext)
	{ 
		pContext.lineWidth = 5;
		pContext.strokeStyle = '#000000';
		pContext.fillStyle = '#FFFFFF';
		pContext.beginPath();
		pContext.arc(0,0,30,0,2*Math.PI,false);
		pContext.arc(0,40,40,0,2*Math.PI,false);
		pContext.arc(0,90,50,0,2*Math.PI,false);
		pContext.stroke();
		pContext.fill();
		pContext.closePath();
		
	};
	
	Snowman.prototype.buttons = function(pContext,pXCor,pYCor)
	{ 
		pContext.lineWidth = 5;
		pContext.strokeStyle = '#000000';
		pContext.fillStyle = '#000000';
		pContext.beginPath();
		pContext.arc(pXCor,pYCor,4,0,2*Math.PI,false);
		pContext.stroke();
		pContext.fill();
		pContext.closePath();
	};
	Snowman.prototype.snowmanHat = function(pContext)
	{ 
		pContext.lineWidth = 5;
		pContext.strokeStyle = '#000000';
		pContext.fillStyle = '#000000';
		pContext.beginPath();
		pContext.moveTo(0,0);
		pContext.lineTo(10,0);
		pContext.lineTo(10,-30);
		pContext.lineTo(30,-30);
		pContext.lineTo(30,0);
		pContext.lineTo(40,0);
		pContext.lineTo(0,0);
		pContext.stroke();
		pContext.fill();
		pContext.closePath();
	};
	Snowman.prototype.arms = function(pContext)
	{ 
		pContext.lineWidth = 5;
		pContext.strokeStyle = '#542100';
		pContext.beginPath();
		pContext.moveTo(0,0);
		pContext.lineTo(30,0);
		pContext.lineTo(30,5);
		pContext.lineTo(30,-5);
		pContext.lineTo(30,0);
		pContext.lineTo(35,0);
		pContext.stroke();
		pContext.closePath();
	};
	Snowman.prototype.carrotNose = function(pContext)
	{ 
		pContext.lineWidth = 1;
		pContext.strokeStyle = '#000000';
		pContext.fillStyle = '#FF5200';
		pContext.beginPath();
		pContext.moveTo(0,0);
		pContext.lineTo(30,-5);
		pContext.lineTo(0,-10);
		pContext.closePath();
		pContext.fill();
		pContext.stroke();
		
	};
	

	return Snowman; 
})();