var Star = (function () {
	function Star(pX, pY) {
		starVectors = new Vector(pX,pY);			
	};

	
	Star.prototype.draw = function(pContext)
	{ 
		pContext.save();
		
		pContext.translate(starVectors.getX(),starVectors.getY());
		pContext.scale(0.1,0.1);
		this.drawStarWhole(pContext,[50,150], [500,150], 5);
		this.drawStarWhole(pContext,[270,490], [50,150],5);
		this.drawStarWhole(pContext,[500,150],[270,490],5);
		pContext.restore();
	};
	
	Star.prototype.drawStarWhole = function(pContext,A, B, depth)
	{ 
		if (depth < 0){
			return null;
		}

		var C = this.divide(this.add(this.multiply(A, 2), B), 3);
		var D = this.divide(this.add(this.multiply(B, 2), A), 3);
		var F = this.divide(this.add(A, B), 2);
    
		var V1 = this.divide(this.minus(F, A), this.length(F, A));
		var V2 = [V1[1], -V1[0]];

		var E = this.add(this.multiply(V2, Math.sqrt(3)/6 * this.length(B, A)), F);

		this.drawLine(pContext,A, B, "black");

		if (depth !=0){
			for (var i=0;i<10;i++)
				this.drawLine(pContext,C, D, "#FFEE00");
		};
    
		this.drawStarWhole(pContext,A, C, depth-1);
		this.drawStarWhole(pContext,C, E, depth-1);
		this.drawStarWhole(pContext,E, D, depth-1);
		this.drawStarWhole(pContext,D, B, depth-1);
	};
	
	Star.prototype.multiply = function(v, num)
	{ 
		return [v[0]*num, v[1]*num];
	};
	
	Star.prototype.divide = function(v, num)
	{ 
		return [v[0]/num, v[1]/num];
	};
	
	Star.prototype.add = function(a, b)
	{ 
		return [a[0]+b[0], a[1]+b[1]];
	};
	
	Star.prototype.minus = function(a, b)
	{ 
		return [a[0]-b[0], a[1]-b[1]];
	};
	
	Star.prototype.length = function(a, b)
	{ 
		return Math.sqrt(Math.pow(a[0] - b[0],2) + Math.pow(a[1] - b[1],2));
	};
	
	Star.prototype.drawLine = function(pContext,a, b, c)
	{ 
		pContext.beginPath();
		pContext.fillStyle = '#7F0000';
		pContext.strokeStyle = c;
		pContext.moveTo(a[0], a[1]);
		pContext.lineTo(b[0], b[1]);
		pContext.closePath();
		pContext.stroke();
		pContext.fill();
	};

	return Star; 
})();