var Tree = (function () {
	function Tree(pX,pY) 
	{
		treeVectors = new Vector(pX,pY);
	};
	
	Tree.prototype.draw = function(pContext)
	{ 
		pContext.save();
		pContext.translate(treeVectors.getX(),treeVectors.getY());
		this.drawTreeWhole(pContext);
		this.decorations(pContext,treeVectors.getX(),treeVectors.getY()+65)
		this.decorations(pContext,treeVectors.getX()-30,treeVectors.getY()+65)
		this.decorations(pContext,treeVectors.getX()+30,treeVectors.getY()+65)
		this.decorations(pContext,treeVectors.getX(),treeVectors.getY()+30)
		this.decorations(pContext,treeVectors.getX()-30,treeVectors.getY()+30)
		this.decorations(pContext,treeVectors.getX()+30,treeVectors.getY()+30)
		pContext.restore();
	};
	
	Tree.prototype.drawTreeWhole = function(pContext)
	{ 
		this.baseTree(pContext);
		pContext.save();
		pContext.translate(0,-20);
		this.treeBranches(pContext);
		pContext.restore();
		pContext.translate(0,-50);
		this.treeBranches(pContext);
		pContext.restore();
	};
	
	Tree.prototype.baseTree = function(pContext)
	{ 
		pContext.lineWidth = 20;
		pContext.strokeStyle = '#542100';
		pContext.beginPath();
		pContext.moveTo(0,0);
		pContext.lineTo(0,100);
		pContext.stroke();
		pContext.closePath();
	};
	
	Tree.prototype.treeBranches = function(pContext)
	{ 
		pContext.lineWidth = 3;
		pContext.strokeStyle = '#000000';
		pContext.fillStyle = '#267F00';
		pContext.beginPath();
		pContext.moveTo(0,0);
		pContext.lineTo(60,100);
		pContext.lineTo(-60,100);
		pContext.closePath();
		pContext.fill();
		pContext.stroke();
	};
	
	Tree.prototype.decorations = function(pContext,pXCor,pYCor)
	{ 
		var fillNum = Math.floor((Math.random()*10)+1);
		
		pContext.lineWidth = 2;
		pContext.strokeStyle = '#000000';
		//Changes colour of decoration
		switch(fillNum)
		{
			case 1:
				pContext.fillStyle = '#000000';
				break;
			case 2:
				pContext.fillStyle = '#FF5821';
				break;
			case 3:
				pContext.fillStyle = '#FFD447';
				break;
			case 4:
				pContext.fillStyle = '#00FF19';
				break;
			case 5:
				pContext.fillStyle = '#FF0090';
				break;
			case 6:
				pContext.fillStyle = '#0800FF';
				break;
			case 7:
				pContext.fillStyle = '#FF4300';
				break;
			case 8:
				pContext.fillStyle = '#FF0008';
				break;
			case 9:
				pContext.fillStyle = '#00FAFF';
				break;
			default:
				pContext.fillStyle = '#F496FF';
				break;
		}
		pContext.beginPath();
		pContext.arc(pXCor,pYCor,10,0,2*Math.PI,false);
		pContext.stroke();
		pContext.fill();
		pContext.closePath();
	};

	return Tree; 
})();